from .common import *
import getopt
PATH=os.getcwd()
sys.path.append(PATH)
import subprocess
def __get_cmd_par():
    try:
        opts, args = getopt.getopt(sys.argv[1:], "h", ["app=","modular=","plug=","user=","pwd=","host=","port=",
        "install","uninstall","pack","upload","cli"])
        # print(opts)
        # print(args)
        server=False
        if 'server' in args:
            server=True
        help=False
        if 'help' in args:
            help=True
       
        appname='app'  #应用名
        modular='index' #模块名
        plug=''  #插件名
        username=''
        password=''
        host='0.0.0.0'
        port=39001

        install=False
        uninstall=False
        pack=False
        upload=False
        cli=False
        if '--cli' in args:
            cli=True
        i=0
        for data in opts:
            if '--app' == data[0]:
                appname=data[1]
            elif '--modular' == data[0]:
                modular=data[1]
            elif '--plug' == data[0]:
                plug=data[1]
            elif '--user' == data[0]:
                username=data[1]
            elif '--pwd' == data[0]:
                password=data[1]
            elif '--host' == data[0]:
                host=data[1]
            elif '--port' == data[0]:
                port=data[1]
            
            elif '--help' == data[0]:
                help=True
            elif '--install' == data[0]:
                install=True
            elif '--uninstall' == data[0]:
                uninstall=True
            elif '--pack' == data[0]:
                pack=True
            elif '--upload' == data[0]:
                upload=True
            elif '--cli' == data[0]:
                cli=True
            i+=1
    except Exception as e:
        print("\033[1;31;40m有关kcweb命令的详细信息，请键入 kcweb help")
        return False
    else:
        return {
            'server':server,
            'appname':appname,'modular':modular,'username':username,'password':password,'plug':plug,'host':host,'port':port,
            'help':help,'install':install,'uninstall':uninstall,'pack':pack,'upload':upload,'cli':cli,
            'index':i
        }
def executable():
    cmd_par=__get_cmd_par()
    if not cmd_par:
        exit()
    if cmd_par['help']:
        try:
            cs=sys.argv[2:][0]
        except:
            cs=None
        print("\033[1;31;40m有关某个命令的详细信息，请键入 kcweb help 命令名")
        print("\033[36m执行 kcweb help server             可查看server相关命令")
        print("\033[36m执行 kcweb help app                可查看赋值相关命令")
        print("\033[36m执行 kcweb help install            可查看安装相关命令")
        print("\033[36m执行 kcweb help pack               可查看打包相关命令")
        print("\033[36m执行 kcweb help upload             可查看上传相关命令")
        print("\033[36m执行 kcweb help uninstall          可查看卸载相关命令\n")
        if 'server' == cs:
            print("\033[32mkcweb --host 0.0.0.0 --port 39001 server     启动web服务")
            print("\033[32mhost、port并不是必须的，如果要使用默认值，您可以使用下面简短的命令来启动服务")
            print("\033[32mkcweb server\n")
        if 'app' == cs:
            print("\033[32mkcweb --app app --modular api --plug plug --install    进行安装")
            print("\033[1;31;40m初始化一个web应用示例,通常情况下app、modular、plug、install同时使用")
            print("\033[32mapp、modular、plug并不是必须的，如果要使用默认值，您可以使用下面简短的命令来安装")
            print("\033[32mkcweb install\n")
        if 'install' == cs:
            print("\033[32mkcweb --install                                                           安装一个默认的应用")
            print("\033[32mkcweb --app app --modular base --install                                  在app应用中安装一个base模块")
            print("\033[32mkcweb --app app --modular base --plug plug1 --install                     在app应用base模块中安装一个plug1插件")
            print("\033[32mkcweb --app app --modular intapp --plug plug1 --user 181*** --install     在app应用intapp模块中安装一个指定用户的plug1插件\n")
        if 'pack' == cs:
            print("\033[32mkcweb --app app --modular api --pack                打包一个模块")
            print("\033[32mkcweb --app app --modular api --plug plug1 --pack   可以打包一个插件\n")
        if 'upload' == cs:
            print("\033[32mkcweb --app app --modular intapp --user 181*** --pwd pwd123 --upload                上传一个intapp模块")
            print("\033[32mkcweb --app app --modular intapp --plug plug1 --user 181*** --pwd pwd123 --upload   向intapp模块中上传一个plug1插件")
            print("\033[1;31;40m注意：181*** 和 pwd123 是您的用户或密码")
        if 'uninstall' == cs:
            print("\033[32mkcweb --app app --modular api --uninstall                  卸载app/api模块")
            print("\033[32mkcweb --app app --modular api --plug plug1 --uninstall     卸载app/api/plug1插件\n")
    else:
        # print(cmd_par)
        if cmd_par['cli']:#通过命令行执行控制器的方法
            from . import web
            import app as application
            app=web(__name__,application)
            try:
                RAW_URI=sys.argv[1]
            except:pass
            else:
                if RAW_URI=='--cli':
                    RAW_URI=''
                app.cli(RAW_URI)
        elif cmd_par['server']:#启动web服务
            if get_sysinfo()['uname'][0]=='Linux':#未测试
                try:
                    f=open("pid",'r')
                    pid=f.read()
                    f.close()
                    if pid:
                        os.system("kill "+pid)
                except:pass
                timeout='600'
                w='2'
                if __name__ == 'kcweb.kcweb':
                    cmd = ['gunicorn','-w', str(w), '-b', cmd_par['host']+':'+str(cmd_par['port']),'-t',timeout, 'server:app']
                    process=subprocess.Popen(cmd)
                    f=open("pid",'w')
                    f.write(str(process.pid))
                    f.close()
                    exit()
            else:
                from . import web
                import app as application
                app=web(__name__,application)
                if __name__ == "kcweb.kcweb":
                    app.run(host=cmd_par['host'],port=int(cmd_par['port']))
        else:
            if cmd_par['install']:#插入 应用、模块、插件
                if cmd_par['appname'] and cmd_par['modular']:
                    server=create(cmd_par['appname'],cmd_par['modular'])
                    t=server.installmodular(cli=True)
                    if cmd_par['plug']:
                        res=server.installplug(cmd_par['plug'],cli=True,username=cmd_par['username'])
                        print(res)
                        if not res[0]:
                            exit()
                    else:
                        if '应用创建成功' in t[1]:
                            print("创建应用成功，接下来在终端中执行：kcweb server 运行项目")
                        else:
                            print(t)
                else:
                    print("\033[1;31;40m安装时 必须指定应该app和modular，参考命令： kcweb --app app --modular api")
                    exit()
            if cmd_par['pack']:#打包 模块、插件
                if cmd_par['appname'] and cmd_par['modular']:
                    server=create(cmd_par['appname'],cmd_par['modular'])
                    if cmd_par['plug']:
                        res=server.packplug(plug=cmd_par['plug'])
                    else:
                        res=server.packmodular()
                    print(res)
                    if not res[0]:
                        exit()
                else:
                    print("\033[1;31;40m打包时 必须指定应该app和modular，参考命令： kcweb --app app --modular api")
                    exit()
            if cmd_par['upload']:#上传 模块、插件
                if cmd_par['appname'] and cmd_par['modular']:
                    server=create(cmd_par['appname'],cmd_par['modular'])
                    if cmd_par['plug']:
                        res=server.packplug(plug=cmd_par['plug'])
                        if res[0]:
                            res=server.uploadplug(cmd_par['plug'],cmd_par['username'],cmd_par['password'],cli=True)
                        else:
                            print(res)
                            exit()
                    else:
                        res=server.packmodular()
                        if res[0]:
                            res=server.uploadmodular(cmd_par['username'],cmd_par['password'],cli=True)
                        else:
                            print(res)
                            exit()
                    print(res)
                    if not res[0]:
                        exit()
                else:
                    print("\033[1;31;40m上传时 必须指定应该app和modular，参考命令： kcweb --app app --modular api")
                    exit()
            if cmd_par['uninstall']:#卸载 模块、插件
                if cmd_par['appname'] and cmd_par['modular']:
                    server=create(cmd_par['appname'],cmd_par['modular'])
                    if cmd_par['plug']:
                        res=server.uninstallplug(plug=cmd_par['plug'])
                    else:
                        res=server.uninstallmodular()
                    print(res)
                    if not res[0]:
                        exit()
                else:
                    print("\033[1;31;40m卸载时 必须指定应该app和modular，参考命令： kcweb --app app --modular api")
                    exit()